---
title: TypedArray.prototype.map()
slug: Web/JavaScript/Reference/Global_Objects/TypedArray/map
tags:
  - ECMAScript 2015
  - JavaScript
  - Method
  - Prototype
  - TypedArray
  - TypedArrays
---
<div>{{JSRef}}</div>

<p>The <strong><code>map()</code></strong> method creates a new typed array with the results of calling a provided function on every element in this typed array. This method has the same algorithm as {{jsxref("Array.prototype.map()")}}<em>.</em> <em>TypedArray</em> is one of the <a href="/en-US/docs/Web/JavaScript/Reference/Global_Objects/TypedArray#TypedArray_objects">typed array types</a> here.</p>

<div>{{EmbedInteractiveExample("pages/js/typedarray-map.html")}}</div>

<div class="hidden">The source for this interactive example is stored in a GitHub repository. If you'd like to contribute to the interactive examples project, please clone <a href="https://github.com/mdn/interactive-examples">https://github.com/mdn/interactive-examples</a> and send us a pull request.</div>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox notranslate"><var>typedArray</var>.map(<var>mapFn</var>[, <var>thisArg</var>])</pre>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt><code><var>mapFn</var></code></dt>
 <dd>
 <p>A callback function that produces an element of the new typed array, taking three arguments:</p>

 <dl>
  <dt><code><var>currentValue</var></code></dt>
  <dd>The current element being processed in the typed array.</dd>
  <dt><code><var>index</var></code> {{optional_inline}}</dt>
  <dd>The index of the current element being processed in the typed array.</dd>
  <dt><code><var>array</var></code> {{optional_inline}}</dt>
  <dd>The typed array <code>map()</code> was called upon.</dd>
 </dl>
 </dd>
 <dt><code><var>thisArg</var></code> {{optional_inline}}</dt>
 <dd>Value to use as <code>this</code> when executing <code><var>mapFn</var></code>.</dd>
</dl>

<h3 id="Return_value">Return value</h3>

<p>A new typed array.</p>

<h2 id="Description">Description</h2>

<p>The <code>map()</code> method calls a provided callback function (<code><var>mapFn</var></code>) once for each element in a typed array, in order, and constructs a new typed array from the results.</p>

<p><code><var>mapFn</var></code> is invoked only for indexes of the typed array which have assigned values; it is not invoked for indexes that are <code>undefined</code>, those which have been deleted, or which have never been assigned values.</p>

<p><code><var>mapFn</var></code> is invoked with three arguments: the value of the element, the index of the element, and the typed array object being traversed.</p>

<p>If a <code><var>thisArg</var></code> parameter is provided to <code>map()</code>, it will be passed to <code><var>mapFn</var></code> when invoked, for use as its <code>this</code> value. Otherwise, the value {{jsxref("undefined")}} will be passed for use as its <code>this</code> value. The <code>this</code> value ultimately observable by <code><var>mapFn</var></code> is determined according to <a href="/en-US/docs/Web/JavaScript/Reference/Operators/this">the usual rules for determining the <code>this</code> seen by a function</a>.</p>

<p><code>map()</code> does not mutate the typed array on which it is called (although <code><var>mapFn</var></code>, if invoked, may do so).</p>

<p>The range of elements processed by <code>map()</code> is set before the first invocation of <code><var>mapFn</var></code>. Elements which are appended to the array after the call to <code>map()</code> begins will not be visited by <code><var>mapFn</var></code>. If existing elements of the typed array are changed, or deleted, their value as passed to <code><var>mapFn</var></code> will be the value at the time <code>map()</code> visits them; elements that are deleted are not visited.</p>

<h2 id="Examples">Examples</h2>

<h3 id="Mapping_a_typed_array_to_a_typed_array_of_square_roots">Mapping a typed array to a typed array of square roots</h3>

<p>The following code takes a typed array and creates a new typed array containing the square roots of the numbers in the first typed array.</p>

<pre class="brush: js notranslate">const numbers = new Uint8Array([1, 4, 9]);
const roots = numbers.map(Math.sqrt);
// roots is now: Uint8Array [1, 2, 3],
// numbers is still Uint8Array [1, 4, 9]
</pre>

<h3 id="Mapping_a_typed_array_of_numbers_using_a_function_containing_an_argument">Mapping a typed array of numbers using a function containing an argument</h3>

<p>The following code shows how <code>map()</code> works when a function requiring one argument is used with it. The argument will automatically be assigned to each element of the typed array as <code>map()</code> loops through the original typed array.</p>

<pre class="brush: js notranslate">const numbers = new Uint8Array([1, 4, 9]);
const doubles = numbers.map(function(num) {
  return num * 2;
});
// doubles is now Uint8Array [2, 8, 18]
// numbers is still Uint8Array [1, 4, 9]
</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('ESDraft', '#sec-%typedarray%.prototype.map', 'TypedArray.prototype.map')}}</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div>

<p>{{Compat("javascript.builtins.TypedArray.map")}}</p>
</div>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{jsxref("TypedArray.prototype.filter()")}}</li>
 <li>{{jsxref("Array.prototype.map()")}}</li>
</ul>
